% % demo of butchershop
load butchershop_kset.mat;
file_name = 'butchershop.jpg';
im = imread(file_name);
if(size(im,3)>1)
    im = rgb2gray(im);
end
im = im2double(im);
im_size = size(im);
% 
focal_length = 35;
k_size = 21;
unit = [0.0013,0.0013,0.0012];
rx_lim = [-6*unit(1),6*unit(1)];
ry_lim = [-6*unit(2),6*unit(2)];
rz_lim = [-7*unit(3),7*unit(3)];
[grid_x,grid_y,grid_z,scale] = make_kernel_grid(rx_lim,ry_lim,rz_lim,unit);
[K] = build_intrisic_mat(im_size,focal_length);
[rot_mat,rot_inv_mat] = build_homography_zrot(grid_x,grid_y,grid_z,scale,K);

[proj_set,proj_weight] = make_homo_projection(rot_mat,rot_inv_mat,loc,'bilinear');
[pose_set,pose_inv_set,pose_ind,w0] = pose_restrict(k_size,k_size,grid_x,grid_y,grid_z,k_set,proj_set,proj_weight,loc,im_size,rot_inv_mat);
[px_mat,py_mat,pxx_mat,pxy_mat,pyy_mat] = gen_partialmat(im_size(1),im_size(2));

%% main loop

sigma_s = 2;sigma_r = 0.5;
support_size = 5;
dt = 1;
thresh = truncate_thresh(im,k_size,2);
maxit = 20;
iter = 1;
err =1;
tol = 1e-6;
L = im;

num_cut = 10;
mode = 'Gaussian';
alpha = 8;

sigma_r = sigma_r*0.93^0;
dt = dt*0.93^0;
thresh = thresh*0.93^0;
ind_used = pose_ind;
    
while (iter<=maxit)&&(err>tol)
    [Px,Py] = prediction(L,sigma_s,sigma_r,support_size,dt,thresh);
    sigma_r = sigma_r*0.93;
    dt = dt*0.93;
    thresh = thresh*0.93;

    [w] = pose_weight_estimatation(Px,Py,im,w0,pose_inv_set);
    
    [K_mat,K_inv_mat] = build_kernelmatrix_basis(w,pose_set,pose_inv_set);
    L_old = L;
    [L] = spv_deconv_partial(K_inv_mat,im,Px,Py,alpha,k_size,px_mat,py_mat,pxx_mat,pxy_mat,pyy_mat);
    
    alpha = alpha * 0.93;

    [pose_set,pose_inv_set,pose_ind,w0] = pose_perturbation(pose_set,pose_inv_set,pose_ind,w,grid_x,grid_y,grid_z,proj_set,proj_weight,im_size,rot_inv_mat,mode,num_cut,ind_used);
    ind_used = pose_ind;

    iter = iter +1;
    err = sqrt(sum(sum((L-L_old).^2)))/size(L,1)/size(L,2);
    figure;imshow(L);
end

%final deconvolution
alpha = 1;
[L] = spv_deconv_partial(K_inv_mat,im,Px,Py,alpha,k_size,px_mat,py_mat,pxx_mat,pxy_mat,pyy_mat);
f1 = fspecial('gaussian',7,0.6);
L1 = imfilter(L,f1,'symmetric');
f2 = fspecial('unsharp',0.95);
L2 = imfilter(L1,f2,'symmetric');
figure;imshow(L2);